<?php

namespace Drupal\synlang\Commands;

use Drush\Commands\DrushCommands;
use Symfony\Component\Yaml\Exception\ParseException;
use Drupal\Component\Serialization\Yaml;

/**
 * A drush command file.
 *
 * @package Drupal\synlang\Commands
 */
class UpdateCommands extends DrushCommands {

  /**
   * Drush command that displays the given text.
   *
   * @command synlang:slupdate
   * @aliases slupdate
   * @usage synlang:slupdate 
   */
  public function slupdate($url) {
    $this->output()->writeln("Обновляем переводы ...");
    $langList = \Drupal::languageManager()->getLanguages();
    foreach ($langList as $key => $lang) {
      $langList[$key] = $key;
    }
    try {
      $data = Yaml::decode(file_get_contents($url));
      $settings = [
        'content' => 1,
        'languages' => $langList,
      ];
      $answer = \Drupal::service('synlang.service')->updateTranslation($data, $settings);
    }
    catch (ParseException $exception) {
      $answer = $exception->getMessage();
    }
    $this->output()->writeln($answer);
  }

  /**
   * Drush command that displays the given text.
   *
   * @command synlang:slupdate_config
   * @aliases slupdate
   * @usage synlang:slupdate_config
   */
  public function slupdate_config($url) {
    $this->output()->writeln("Обновляем переводы конфигов ...");
    $langList = \Drupal::languageManager()->getLanguages();
    foreach ($langList as $key => $lang) {
      $langList[$key] = $key;
    }
    try {
      $data = Yaml::decode(file_get_contents($url));
      $settings = [
        'content' => 1,
        'languages' => $langList,
      ];
      $answer = \Drupal::service('synlang.service')->updateTranslation($data, $settings);
    }
    catch (ParseException $exception) {
      $answer = $exception->getMessage();
    }
    $this->output()->writeln($answer);
  }

}
